import java.io.*;
import java.text.*;
import java.util.Locale;
import java.util.StringTokenizer;


public class Simulation {
	public static void main (String[] args) {
		int steps = 10;
		int runs = 2;
		if(args.length!=0) {
			steps = Integer.valueOf(args[0]).intValue();
			runs = Integer.valueOf(args[1]).intValue();
		}
		
		int carsRun;
		int i, j, k, l, m, r, step;
		int[][][] w = new int[13][13][84];
		int[] f = new int[84];
		int matrizen[][][] = new int[2*runs+1][][];
		double ergebnis[][];
		
		NumberFormat nf = NumberFormat.getInstance(Locale.US);
		nf.setMaximumFractionDigits(1);
		nf.setMinimumFractionDigits(1);
		
		String line;
		StringTokenizer tok;
		BufferedReader reader;
		BufferedWriter writer;
			
		ODMatrix ODM = new ODMatrix(1);
		int NrCe=0;
		Centroid centroids[] = new Centroid[1];
		int NrCr=0;
		Crossing crossings[] = new Crossing[1];
		int NrSe=0;
		Section sections[] = new Section[1];
		
		try {
			reader = new BufferedReader(new FileReader("Centroids.txt"));//FileReader anlegen
			line = reader.readLine();
			NrCe = Integer.valueOf(line).intValue();
			reader.close();
	
			ODM = new ODMatrix(NrCe);

			centroids = new Centroid[NrCe];
			for(i=0; i<NrCe; i++) {
				centroids[i] = new Centroid(i, ODM);
				System.out.println("Centroid " + (i+1) + " angelegt.");
			}
		} catch (IOException ioe){}
		
		try {
			reader = new BufferedReader(new FileReader("Crossings.txt"));
			line = reader.readLine();
			NrCr = Integer.valueOf(line).intValue();
			crossings = new Crossing[NrCr];
			for(i=0; i<NrCr; i++) {
				line = reader.readLine();
				j = Integer.valueOf(line).intValue();
				crossings[i] = new Crossing(j);
				System.out.println("Crossing " + (i+1) + " mit " + j + " Armen angelegt.");
			}
			reader.close();
		} catch (IOException ioe){}

		try {
			reader = new BufferedReader(new FileReader("Sections.txt"));
			line = reader.readLine();
			NrSe = Integer.valueOf(line).intValue();
			reader.close();
				
			sections = new Section[NrSe];
				
			i = 0;
			reader = new BufferedReader(new FileReader("SectionsCrCr.txt"));
			while (reader.ready()) {
				line = reader.readLine();
				tok = new StringTokenizer(line, " ");
				j = Integer.valueOf(tok.nextToken()).intValue()-1;
				k = Integer.valueOf(tok.nextToken()).intValue()-1;
				l = Integer.valueOf(tok.nextToken()).intValue()-1;
				m = Integer.valueOf(tok.nextToken()).intValue()-1;
				sections[i] = new Section(j, k, l, m);
				System.out.println("Sektion " + (i+1) + " von Crossing " + (j+1) + " nach Crossing " + (l+1) + " angelegt.");
				i++;
			}
			reader.close();
				
			reader = new BufferedReader(new FileReader("SectionsCeCr.txt"));
			while (reader.ready()) {
				line = reader.readLine();
				tok = new StringTokenizer(line, " ");
				j = Integer.valueOf(tok.nextToken()).intValue()-1;
				k = Integer.valueOf(tok.nextToken()).intValue()-1;
				l = Integer.valueOf(tok.nextToken()).intValue()-1;
				sections[i] = new Section(9999, j, k, l);
				System.out.println("Sektion " + (i+1) + " von Centroid " + (j+1) + " nach Crossing " + (k+1) + " angelegt.");
				i++;
			}
			reader.close();

			reader = new BufferedReader(new FileReader("SectionsCrCe.txt"));
			while (reader.ready()) {
				line = reader.readLine();
				tok = new StringTokenizer(line, " ");
				j = Integer.valueOf(tok.nextToken()).intValue()-1;
				k = Integer.valueOf(tok.nextToken()).intValue()-1;
				l = Integer.valueOf(tok.nextToken()).intValue()-1;
				sections[i] = new Section(j, k, 9999, l);
				System.out.println("Sektion " + (i+1) + " von Crossing " + (j+1) + " nach Centroid " + (l+1) + " angelegt.");
				i++;
			}
			reader.close();

		} catch (IOException ioe){}

		try {
			reader = new BufferedReader(new FileReader("Flow.txt"));
			while (reader.ready()) {
				line = reader.readLine();
				tok = new StringTokenizer(line, " ");
				i = Integer.valueOf(tok.nextToken()).intValue()-1;
				j = Integer.valueOf(tok.nextToken()).intValue()-1;
				k = Integer.valueOf(tok.nextToken()).intValue()-1;
				l = Integer.valueOf(tok.nextToken()).intValue();
				crossings[i].odMatrix[j][k] = l;
				System.out.println("Flow " + l + " an Crossing " + (i+1) + " von " + (j+1) + " nach " + (k+1) + " eingetragen.");
			}
			reader.close();
		} catch (IOException ioe){}

		for(i=0; i<NrCr; i++)
			crossings[i].calculateAnteile();

		for(r=0; r<runs; r++) {			
			System.out.println("\n\n\nDurchlauf "+(r+1)+"\n");
			ODM.clear();
			for(i=0; i<NrCe; i++)
				centroids[i].clear();
			for(i=0; i<NrCr; i++)
				crossings[i].clear();

			for(i=0; i<NrSe; i++)
				if(sections[i].fromC==9999) {
					j = crossings[sections[i].toC].odMatrix[sections[i].toA][crossings[sections[i].toC].arme];
					if(j>0) {
						ODM.carsOut += j;
						Fahrzeug[] fz = new Fahrzeug[j];
						for(k=0; k<j; k++) 
							fz[k] = new Fahrzeug(sections[i].fromA);
						FahrzeugHandle fh = new FahrzeugHandle(fz);
						centroids[sections[i].fromA].schlangeE = fh;
					}
				}
			ODM.carsRun = ODM.carsOut;

			step = 0;
			System.out.println("Vorwaerts berechnen...");
			while(step<steps && ODM.carsOut>0) {
				System.out.print("Schritt: " + (step+1));
				
				for(i=0; i<NrSe; i++) {
					if(sections[i].fromC==9999) {
						if(crossings[sections[i].toC].fromFH[sections[i].toA]!=null) System.out.println("Fehler in Eingabedateien!");
						crossings[sections[i].toC].fromFH[sections[i].toA] = centroids[sections[i].fromA].schlangeE;
						centroids[sections[i].fromA].schlangeE = null;
					} else if(sections[i].toC==9999){
						if(centroids[sections[i].toA].schlangeA!=null) System.out.println("Fehler in Eingabedateien!");
						centroids[sections[i].toA].schlangeA = crossings[sections[i].fromC].toFH[sections[i].fromA];
						crossings[sections[i].fromC].toFH[sections[i].fromA] = null;
					} else {
						if(crossings[sections[i].toC].fromFH[sections[i].toA]!=null) System.out.println("Fehler in Eingabedateien!");
						crossings[sections[i].toC].fromFH[sections[i].toA] = crossings[sections[i].fromC].toFH[sections[i].fromA];
						crossings[sections[i].fromC].toFH[sections[i].fromA] = null;
					}				
				}
				
				for(i=0; i<NrCr; i++)
					crossings[i].verteile();
				
				for(i=0; i<NrCe; i++)
					centroids[i].ausfahren();
				
				System.out.println(" Fahrzeuge im System: " + ODM.carsOut);

				step++;
			}
			ODM.rechneHoch();
			ODM.gibAus();
			matrizen[2*r] = ODM.gibValue();
			
			ODM.clear();
			for(i=0; i<NrCe; i++)
				centroids[i].clear();
			for(i=0; i<NrCr; i++)
				crossings[i].clear();

			for(i=0; i<NrSe; i++)
				if(sections[i].toC==9999) {
					j = crossings[sections[i].fromC].odMatrix[crossings[sections[i].fromC].arme][sections[i].fromA];
					if(j>0) {
						ODM.carsOut += j;
						Fahrzeug[] fz = new Fahrzeug[j];
						for(k=0; k<j; k++) 
							fz[k] = new Fahrzeug(sections[i].toA);
						FahrzeugHandle fh = new FahrzeugHandle(fz);
						centroids[sections[i].toA].schlangeA = fh;
					}
				}
			ODM.carsRun = ODM.carsOut;

			step = 0;
			System.out.println("\n\nRueckwaerts berechnen...");
			while(step<steps && ODM.carsOut>0) {
				System.out.print("Schritt: " + (step+1));
				
				for(i=0; i<NrSe; i++) {
					if(sections[i].toC==9999) {
						if(crossings[sections[i].fromC].toFH[sections[i].fromA]!=null) System.out.println("Fehler in Eingabedateien!");
						crossings[sections[i].fromC].toFH[sections[i].fromA] = centroids[sections[i].toA].schlangeA;
						centroids[sections[i].toA].schlangeA = null;
					} else if(sections[i].fromC==9999){
						if(centroids[sections[i].fromA].schlangeE!=null) System.out.println("Fehler in Eingabedateien!");
						centroids[sections[i].fromA].schlangeE = crossings[sections[i].toC].fromFH[sections[i].toA];
						crossings[sections[i].toC].fromFH[sections[i].toA] = null;
					} else {
						if(crossings[sections[i].fromC].toFH[sections[i].fromA]!=null) System.out.println("Fehler in Eingabedateien!");
						crossings[sections[i].fromC].toFH[sections[i].fromA] = crossings[sections[i].toC].fromFH[sections[i].toA];
						crossings[sections[i].toC].fromFH[sections[i].toA] = null;
					}				
				}
				
				for(i=0; i<NrCr; i++)
					crossings[i].verteileR();
				
				for(i=0; i<NrCe; i++)
					centroids[i].ausfahrenR();
				
				System.out.println(" Fahrzeuge im System: " + ODM.carsOut);
				step++;
			}
			ODM.rechneHoch();
			ODM.gibAus();
			matrizen[2*r+1] = ODM.gibValue();
		}

		ergebnis = new double[matrizen[0][0].length][matrizen[0][0].length];
		matrizen[2*runs] = new int[matrizen[0][0].length][matrizen[0][0].length];
		for(i=0; i<matrizen[0][0].length; i++)
			for(j=0; j<matrizen[0][0].length; j++) {
				matrizen[2*runs][i][j] = 0;
				for(k=0; k<2*runs; k++)
					matrizen[2*runs][i][j] += matrizen[k][i][j]; 
				ergebnis[i][j] = 1.0 * matrizen[2*runs][i][j] / (2*runs);
			}
		System.out.print("\n\n************\n* ERGEBNIS *\n************\n    |");
		for(i=0; i<ergebnis.length; i++)
			System.out.print("\t " + (i+1));
		System.out.print("\n------");
		for(i=0; i<ergebnis.length; i++)
			System.out.print("--------");
		for(i=0; i<ergebnis.length; i++) {
			System.out.print("\n" + DoFormat(Integer.toString((i+1)), 3, true) + " | ");
			for(j=0; j<ergebnis.length; j++)
				System.out.print("\t" + DoFormat(nf.format(ergebnis[i][j]), 5, true));
		}
		
		try 
		{ 
			File out = new File("OD-Matrix.xls"); 
			FileWriter fw = new FileWriter(out); 
			BufferedWriter bw = new BufferedWriter(fw); 
	
			bw.write("von \\ nach");
			for(i=0; i<ergebnis.length; i++)
				bw.write("\t " + (i+1));
			for(i=0; i<ergebnis.length; i++) 
			{
				bw.write("\n" + DoFormat(Integer.toString((i+1)), 3, true));
				for(j=0; j<ergebnis.length; j++)
					bw.write("\t " + DoFormat(nf.format(ergebnis[i][j]), 5, true).replace('.',','));
			}
			bw.close(); 
			System.out.println("\n\nDie OD-Matrix wurde in OD-Matrix.xls gespeichert.");
		} 
		catch (IOException ioe) 
		{ 
			System.out.println("\n\n!!!Fehler!!! => "+ioe); 
		} 
	}

	static String DoFormat(String s, int width, boolean right) {
		final String filler = "                ";
		final int fillwidth = filler.length();
		int d, i = width - s.length();
		
		while(i>0){
			String f = filler.substring(0,d=(i>=fillwidth)?fillwidth:i);
			i -= d;
			if(right)
				s = f + s;
			else
				s += f;
		}
		return s;
	}
}


class ODMatrix{
	public int[][] value;
	public int carsRun;
	public int carsOut;
	
	public ODMatrix(int nr) {
		value = new int[nr][nr];
		for(int i=0; i<nr; i++)
			for(int j=0; j<nr; j++)
				value[i][j] = 0;
		carsOut = 0;
	}
	
	public int[][] gibValue() {
		int[][] v = new int[value.length][value.length];
		for(int i=0; i<v.length; i++)
			for(int j=0; j<v.length; j++)
				v[i][j] = value[i][j];
		return v;
	}
	
	public void clear() {
		for(int i=0; i<value.length; i++)
			for(int j=0; j<value.length; j++)
				value[i][j] = 0;
		carsOut = 0;
		carsRun = 0;
	}
	
	public void rechneHoch() {
		if(carsRun-carsOut==0) return;
		for(int i=0; i<value.length; i++)
			for(int j=0; j<value.length; j++)
				value[i][j] = (int)(1.0*value[i][j] * carsRun / (carsRun-carsOut) + .5);
		carsOut = 0;
	}

	public void gibAus() {
		int i, j;
		System.out.print("\n  |");
		for(i=0; i<value.length; i++)
			System.out.print("\t" + (i+1));
		System.out.print("\n---");
		for(i=0; i<value.length; i++)
			System.out.print("--------");
		for(i=0; i<value.length; i++) {
			System.out.print("\n" + (i+1) + " | ");
			for(j=0; j<value.length; j++)
				System.out.print("\t" + value[i][j]);
		}
		System.out.println();
	}
}


class Fahrzeug {
	public int o;
	public int d;
	
	public Fahrzeug(int od) {
		o = od;
		d = od;
	}
}


class FahrzeugHandle {
	public Fahrzeug[] fahrzeuge;
	
	public FahrzeugHandle(Fahrzeug[] fahrzeuge) {
		this.fahrzeuge = fahrzeuge;
	}
	
	void nimmFahrzeuge(Fahrzeug[] fahrzeuge) {
		this.fahrzeuge = fahrzeuge;
	}
	
	public Fahrzeug[] gibFahrzeuge() {
		Fahrzeug[] hf = fahrzeuge;
		fahrzeuge = null;

		return hf;
	}
	
	public void nimmFahrzeug(Fahrzeug fz) {
		Fahrzeug[] fzg = new Fahrzeug[fahrzeuge.length+1];

		for(int i=0; i<fahrzeuge.length; i++)
			fzg[i] = fahrzeuge[i];
		fzg[fahrzeuge.length] = fz;

		fahrzeuge = fzg;
	}
	
	public Fahrzeug gibFahrzeug() {
		Fahrzeug[] fzg;
		Fahrzeug fz = fahrzeuge[0];
		if(fahrzeuge.length>1)
			fzg = new Fahrzeug[fahrzeuge.length-1];
		else {
			fahrzeuge = null;
			return fz;
		}

		for(int i=0; i<fzg.length; i++)
			fzg[i] = fahrzeuge[i+1];

		fahrzeuge = fzg;		

		return fz;
	}		
	
	public void shakeHandle() {
		int rnd;
		Fahrzeug[] fzg = new Fahrzeug[fahrzeuge.length];
		
		for(int i=0; i<fzg.length; i++) {
			rnd = (int)(Math.random()*fzg.length);
			while(fzg[rnd]!=null){
				rnd++;
				if(rnd==fzg.length) rnd = 0;
			}
			fzg[rnd] = fahrzeuge[i];
		}
		
		this.fahrzeuge = fzg;
	}
}


class Centroid {
	public FahrzeugHandle schlangeE;
	public FahrzeugHandle schlangeA;
	public ODMatrix odMatrix;
	public int number;
	
	public Centroid(int number, ODMatrix odMatrix) {
		this.number = number;
		this.odMatrix = odMatrix;
	}
	
	public void clear() {
		schlangeE = null;
		schlangeA = null;
	}
	
	public void ausfahren() {
		if (schlangeA==null) return;
		Fahrzeug[] hf = schlangeA.gibFahrzeuge();
		for(int i=0; i<hf.length; i++) {
			odMatrix.value[hf[i].o][number]++;
			odMatrix.carsOut--;
		}
		schlangeA = null;
	}

	public void ausfahrenR() {
		if (schlangeE==null) return;
		Fahrzeug[] hf = schlangeE.gibFahrzeuge();
		for(int i=0; i<hf.length; i++) {
			odMatrix.value[number][hf[i].d]++;
			odMatrix.carsOut--;
		}
		schlangeE = null;
	}
}


class Crossing {
	public FahrzeugHandle[] fromFH;
	public FahrzeugHandle[] toFH;
	public int arme;
	public int[][] odMatrix;
	public double[][] odAnteile;
	public double[][] odRAnteile;
	
	public Crossing(int arme) {
		this.arme = arme;
		fromFH = new FahrzeugHandle[arme];
		toFH = new FahrzeugHandle[arme];
		odMatrix = new int[arme+1][arme+1];
		for(int i=0; i<arme; i++)
			for(int j=0; j<arme+1; j++)
				odMatrix[i][j] = 0;
		odAnteile = new double[arme][arme];
		odRAnteile = new double[arme][arme];
	}
	
	public void clear() {
		for(int i=0; i<arme; i++) {
			fromFH[i] = null;
			toFH[i] = null;
		}
	}
	
	public void calculateAnteile() {
		for(int i=0; i<arme; i++) {
			int k = 0;
			int l = 0;
			for(int j=0; j<arme; j++) {
				k += odMatrix[i][j];
				l += odMatrix[j][i];
			}
			odMatrix[i][arme] = k;
			odMatrix[arme][i] = l;
		}
		for(int i=0; i<arme; i++)	
			for(int j=0; j<arme; j++) {
				if(odMatrix[i][arme]>0)
					odAnteile[i][j] = 1.0*odMatrix[i][j]/odMatrix[i][arme];
				else
					odAnteile[i][j] = 0;			
				if(odMatrix[arme][i]>0)
					odRAnteile[j][i] = 1.0*odMatrix[j][i]/odMatrix[arme][i];
				else
					odRAnteile[j][i] = 0;			
			}
	}
	
	public void verteile(){
		shakeFHs();
		
		for(int i=0; i<arme; i++) {
			if(fromFH[i]!=null) {
				int nr = fromFH[i].fahrzeuge.length;
				int rest = nr;
				for(int j=0; j<arme; j++)
					for(int k=0; k<(int)(odAnteile[i][j]*nr); k++) {
						if(toFH[j]!=null)
							toFH[j].nimmFahrzeug(fromFH[i].gibFahrzeug());
						else {
							Fahrzeug[] fz = new Fahrzeug[1];
							fz[0] = fromFH[i].gibFahrzeug();
							toFH[j] = new FahrzeugHandle(fz);
						}
						rest--;
					}
				int j = (int)(Math.random()*arme);
				while(rest>0) {
					if(odAnteile[i][j]>0) {
						if(toFH[j]!=null)
							toFH[j].nimmFahrzeug(fromFH[i].gibFahrzeug());
						else {
							Fahrzeug[] fz = new Fahrzeug[1];
							fz[0] = fromFH[i].gibFahrzeug();
							toFH[j] = new FahrzeugHandle(fz);
						}
						rest--;
					}
					j++;
					if(j==arme) j = 0;
				}
				fromFH[i] = null;
			}
		}
		
		shakeTHs();
	}
	
	public void verteileR(){
		shakeTHs();
		
		for(int i=0; i<arme; i++) {
			if(toFH[i]!=null) {
				int nr = toFH[i].fahrzeuge.length;
				int rest = nr;
				for(int j=0; j<arme; j++)
					for(int k=0; k<(int)(odRAnteile[j][i]*nr); k++) {
						if(fromFH[j]!=null)
							fromFH[j].nimmFahrzeug(toFH[i].gibFahrzeug());
						else {
							Fahrzeug[] fz = new Fahrzeug[1];
							fz[0] = toFH[i].gibFahrzeug();
							fromFH[j] = new FahrzeugHandle(fz);
						}
						rest--;
					}
				int j = (int)(Math.random()*arme);
				while(rest>0) {
					if(odAnteile[j][i]>0) {
						if(fromFH[j]!=null)
							fromFH[j].nimmFahrzeug(toFH[i].gibFahrzeug());
						else {
							Fahrzeug[] fz = new Fahrzeug[1];
							fz[0] = toFH[i].gibFahrzeug();
							fromFH[j] = new FahrzeugHandle(fz);
						}
						rest--;
					}
					j++;
					if(j==arme) j = 0;
				}
				toFH[i] = null;
			}
		}
		
		shakeFHs();
	}
	
	public void shakeFHs() {
		for(int i=0; i<arme; i++)
			if(fromFH[i]!=null) fromFH[i].shakeHandle();
	}

	public void shakeTHs() {
		for(int i=0; i<arme; i++)
			if(toFH[i]!=null) toFH[i].shakeHandle();
	}
}


class Section {
	public int fromC;
	public int fromA;
	public int toC;  
	public int toA;
	
	public Section(int fromC, int fromA, int toC, int toA) {
		this.fromC = fromC;
		this.fromA = fromA;
		this.toC = toC;
		this.toA = toA;
	}
}